Necessary shell script

1, Server system configuration initialization

#/bin/bash
# Install system performance analysis tools and others
yum install gcc make autoconf vim sysstat net-tools iostat iftop iotp wget lrzsz lsof unzip openssh-clients net-tool vim ntpdate -y
# Set time zone and synchronize time
ln -s /usr/share/zoneinfo/Asia/Shanghai /etc/localtime
if ! crontab -l |grep ntpdate & amp;>/dev/null ; then
    (echo "* 1 * * * ntpdate time.windows.com >/dev/null 2> & amp;1";crontab -l) |crontab
fi
 
# Disable selinux
sed -i '/SELINUX/{s/permissive/disabled/}' /etc/selinux/config
 
# Turn off the firewall
if egrep "7.[0-9]" /etc/redhat-release & amp;>/dev/null; then
    systemctl stop firewalld
    systemctl disable firewalld
elif egrep "6.[0-9]" /etc/redhat-release &>/dev/null; then
    service iptables stop
    chkconfig iptables off
fi
 
#History command displays operation time
if ! grep HISTTIMEFORMAT /etc/bashrc; then
    echo 'export HISTTIMEFORMAT="%Y-%m-%d %H:%M:%S `whoami` "' >> /etc/bashrc
fi
 
# SSH timeout
if ! grep "TMOUT=600" /etc/profile &>/dev/null; then
    echo "export TMOUT=600" >> /etc/profile
fi
 
# Disable root remote login. Remember to add a normal user to the system and give su permission to root.
sed -i 's/#PermitRootLogin yes/PermitRootLogin no/' /etc/ssh/sshd_config
 
# Disable scheduled tasks from sending emails to
sed -i 's/^MAILTO=root/MAILTO=""/' /etc/crontab
 
#Set the maximum number of open files
if ! grep "* soft nofile 65535" /etc/security/limits.conf & amp;>/dev/null; then
cat >> /etc/security/limits.conf << EOF
    * soft nofile 65535
    *hard nofile 65535
EOF
fi
 
# System kernel optimization
cat >> /etc/sysctl.conf << EOF
net.ipv4.tcp_syncookies = 1
net.ipv4.tcp_max_tw_buckets = 20480
net.ipv4.tcp_max_syn_backlog = 20480
net.core.netdev_max_backlog = 262144
net.ipv4.tcp_fin_timeout = 20
EOF
 
# Reduce SWAP usage
echo "0" > /proc/sys/vm/swappiness

2. Create multiple users in batches and set passwords

#!/bin/bash
USER_LIST=$@
USER_FILE=./user.info
for USER in $USER_LIST;do
 if ! id $USER & amp;>/dev/null; then
  PASS=$(echo $RANDOM |md5sum |cut -c 1-8)
  useradd $USER
  echo $PASS | passwd --stdin $USER &>/dev/null
  echo "$USER $PASS" >> $USER_FILE
  echo "$USER User create successful."
 else
  echo "$USER User already exists!"
 fi
done

3. Check server utilization with one click

#!/bin/bash
function cpu(){
 
 util=$(vmstat | awk '{if(NR==3)print $13 + $14}')
 iowait=$(vmstat | awk '{if(NR==3)print $16}')
 echo "CPU - usage: ${util}%, waiting for disk IO corresponding usage: ${iowait}:${iowait}%"
 
}
function memory (){
 
 total=`free -m |awk '{if(NR==2)printf "%.1f",$2/1024}'`
    used=`free -m |awk '{if(NR==2) printf "%.1f",($2-$NF)/1024}'`
    available=`free -m |awk '{if(NR==2) printf "%.1f",$NF/1024}'`
    echo "Memory - Total size: ${total}G , Used: ${used}G , Remaining: ${available}G"
}
disk(){
 
 fs=$(df -h |awk '/^\/dev/{print $1}')
    for p in $fs; do
        mounted=$(df -h |awk '$1=="'$p'"{print $NF}')
        size=$(df -h |awk '$1=="'$p'"{print $2}')
        used=$(df -h |awk '$1=="'$p'"{print $3}')
        used_percent=$(df -h |awk '$1=="'$p'"{print $5}')
        echo "Hard disk - mount point: $mounted, total size: $size, usage: $used, usage rate: $used_percent"
    done
 
}
function tcp_status() {
    summary=$(ss -antp |awk '{status[$1] + + }END{for(i in status) printf i":"status[i]" "}')
    echo "TCP connection status - $summary"
}
cpu
memory
disk
tcp_status

4. Find processes that occupy too much CPU memory

#!/bin/bash
echo "-----------------------------CUP occupied top 10 sorting----------------------- ---------"
ps -eo user,pid,pcpu,pmem,args --sort=-pcpu |head -n 10
echo "-----------------------------Sort the top 10 memory usage---------------------- ---------"
ps -eo user,pid,pcpu,pmem,args --sort=-pmem |head -n 10

5. Check the real-time traffic of the network card

#!/bin/bash
eth0=$1
echo -e "Traffic in--Traffic out"
while true; do
 old_in=$(cat /proc/net/dev |grep $eth0 |awk '{print $2}')
 old_out=$(cat /proc/net/dev |grep $eth0 |awk '{print $10}')
 sleep 1
 new_in=$(cat /proc/net/dev |grep $eth0 |awk '{print $2}')
 new_out=$(cat /proc/net/dev |grep $eth0 |awk '{print $10}')
 in=$(printf "%.1f%s" "$((($new_in-$old_in)/1024))" "KB/s")
 out=$(printf "%.1f%s" "$((($new_out-$old_out)/1024))" "KB/s")
 echo "$in $out"
done

6. Script to monitor disk utilization of multiple servers

#!/bin/bash
HOST_INFO=host.info
for IP in $(awk '/^[^#]/{print $1}' $HOST_INFO); do
 #Get the username and port
    USER=$(awk -v ip=$IP 'ip==$1{print $2}' $HOST_INFO)
    PORT=$(awk -v ip=$IP 'ip==$1{print $3}' $HOST_INFO)
 #Create temporary files to save information
    TMP_FILE=/tmp/disk.tmp
 #Get host disk information through public key login
    ssh -p $PORT $USER@$IP 'df -h' > $TMP_FILE
 #Analyze disk space occupied
    USE_RATE_LIST=$(awk 'BEGIN{OFS="="}/^\/dev/{print $NF,int($5)}' $TMP_FILE)
 #Loop the disk list and make judgments
    for USE_RATE in $USE_RATE_LIST; do
  #Take out the value on the right side of the equal sign (=) and mount point name
        PART_NAME=${USE_RATE%=*}
  #Get the value to the left of the equal sign (=) Disk utilization
        USE_RATE=${USE_RATE#*=}
  #make judgment
        if [ $USE_RATE -ge 80 ]; then
            echo "Warning: $PART_NAME Partition usage $USE_RATE%!"
    echo "The disk space of server $IP is too high, please deal with it in time" | mail -s "Insufficient space warning" Your [email protected]
  else
   echo "The $PART_NAME directory space of server $IP is good"
        fi
    done
done

7. Check whether the website is abnormal in batches and notify by email

#!/bin/bash
URL_LIST="www.baidu.com www.ctnrs.com www.der-matech.net.cn www.der-matech.com.cn www.der-matech.cn www.der-matech.top www.der- matech.org"
for URL in $URL_LIST; do
    FAIL_COUNT=0
    for ((i=1;i<=3;i + + )); do
        HTTP_CODE=$(curl -o /dev/null --connect-timeout 3 -s -w "%{http_code}" $URL)
        if [ $HTTP_CODE -eq 200 ]; then
            echo "$URL OK"
            break
        else
            echo "$URL retry $FAIL_COUNT"
            let FAIL_COUNT + +
        fi
    done
    if [ $FAIL_COUNT -eq 3 ]; then
        echo "Warning: $URL Access failure!"
  echo "The website $URL is broken, please deal with it in time" | mail -s "$URL website is high risk" [email protected]
    fi
done

8. Batch host remote execution command script

#!/bin/bash
COMMAND=$*
HOST_INFO=host.info
for IP in $(awk '/^[^#]/{print $1}' $HOST_INFO); do
    USER=$(awk -v ip=$IP 'ip==$1{print $2}' $HOST_INFO)
    PORT=$(awk -v ip=$IP 'ip==$1{print $3}' $HOST_INFO)
    PASS=$(awk -v ip=$IP 'ip==$1{print $4}' $HOST_INFO)
    expect -c "
       spawn ssh -p $PORT $USER@$IP
       expect {
          "(yes/no)" {send "yes\r"; exp_continue}
          "password:" {send "$PASS\r"; exp_continue}
          "$USER@*" {send "$COMMAND\r exit\r"; exp_continue}
       }
    "
    echo "--------------------------"
done

9. One-click deployment of LNMP website platform script

#!/bin/bash
NGINX_V=1.15.6
PHP_V=5.6.36
TMP_DIR=/tmp
 
INSTALL_DIR=/usr/local
 
PWD_C=$PWD
 
echo
echo -e "\tMenu\\
"
echo -e "1. Install Nginx"
echo -e "2. Install PHP"
echo -e "3. Install MySQL"
echo -e "4. Deploy LNMP"
echo -e "9. Quit"
 
function command_status_check() {
 if [ $? -ne 0 ]; then
  echo $1
  exit
 fi
}
 
function install_nginx() {
    cd $TMP_DIR
    yum install -y gcc gcc-c++ make openssl-devel pcre-devel wget
    wget http://nginx.org/download/nginx-${NGINX_V}.tar.gz
    tar zxf nginx-${NGINX_V}.tar.gz
    cd nginx-${NGINX_V}
    ./configure --prefix=$INSTALL_DIR/nginx \
    --with-http_ssl_module \
    --with-http_stub_status_module \
    --with-stream
    command_status_check "Nginx - Platform environment check failed!"
    make -j 4
    command_status_check "Nginx - Compilation failed!"
    make install
    command_status_check "Nginx - Installation failed!"
    mkdir -p $INSTALL_DIR/nginx/conf/vhost
    alias cp=cp ; cp -rf $PWD_C/nginx.conf $INSTALL_DIR/nginx/conf
    rm -rf $INSTALL_DIR/nginx/html/*
    echo "ok" > $INSTALL_DIR/nginx/html/status.html
    echo '<?php echo "ok"?>' > $INSTALL_DIR/nginx/html/status.php
    $INSTALL_DIR/nginx/sbin/nginx
    command_status_check "Nginx - Startup failed!"
}
 
function install_php() {
 cd $TMP_DIR
    yum install -y gcc gcc-c + + make gd-devel libxml2-devel \
        libcurl-devel libjpeg-devel libpng-devel openssl-devel \
        libmcrypt-devel libxslt-devel libtidy-devel
    wget http://docs.php.net/distributions/php-${PHP_V}.tar.gz
    tar zxf php-${PHP_V}.tar.gz
    cd php-${PHP_V}
    ./configure --prefix=$INSTALL_DIR/php \
    --with-config-file-path=$INSTALL_DIR/php/etc \
    --enable-fpm --enable-opcache \
    --with-mysql --with-mysqli --with-pdo-mysql \
    --with-openssl --with-zlib --with-curl --with-gd \
    --with-jpeg-dir --with-png-dir --with-freetype-dir \
    --enable-mbstring --enable-hash
    command_status_check "PHP - Platform environment check failed!"
    make -j 4
    command_status_check "PHP - Compilation failed!"
    make install
    command_status_check "PHP - Installation failed!"
    cp php.ini-production $INSTALL_DIR/php/etc/php.ini
    cp sapi/fpm/php-fpm.conf $INSTALL_DIR/php/etc/php-fpm.conf
    cp sapi/fpm/init.d.php-fpm /etc/init.d/php-fpm
    chmod +x /etc/init.d/php-fpm
    /etc/init.d/php-fpm start
    command_status_check "PHP - Startup failed!"
}
 
read -p "Please enter the number:" number
case $number in
    1)
        install_nginx;;
    2)
        install_php;;
    3)
        install_mysql;;
    4)
        install_nginx
        install_php
        ;;
    9)
        exit;;
esac

10. Script to monitor whether the MySQL master-slave synchronization status is abnormal

#!/bin/bash
HOST=localhost
USER=root
PASSWD=123.com
IO_SQL_STATUS=$(mysql -h$HOST -u$USER -p$PASSWD -e 'show slave status\G' 2>/dev/null |awk '/Slave_.*_Running:/{print $1$2 }')
for i in $IO_SQL_STATUS; do
    THREAD_STATUS_NAME=${i%:*}
    THREAD_STATUS=${i#*:}
    if [ "$THREAD_STATUS" != "Yes" ]; then
        echo "Error: MySQL Master-Slave $THREAD_STATUS_NAME status is $THREAD_STATUS!" |mail -s "Master-Slave Staus" [email protected]
    fi
done

11. MySql database backup script

Branch database backup

mysqldump -uroot -pxxx -B A > A.sql
#!/bin/bash
DATE=$(date + %F_%H-%M-%S)
HOST=localhost
USER=backup
PASS=123.com
BACKUP_DIR=/data/db_backup
DB_LIST=$(mysql -h$HOST -u$USER -p$PASS -s -e "show databases;" 2>/dev/null |egrep -v "Database|information_schema|mysql|performance_schema|sys\ ")
 
for DB in $DB_LIST; do
    BACKUP_NAME=$BACKUP_DIR/${DB}_${DATE}.sql
    if ! mysqldump -h$HOST -u$USER -p$PASS -B $DB > $BACKUP_NAME 2>/dev/null; then
        echo "$BACKUP_NAME backup failed!"
    fi
done

Table backup

mysqldump -uroot -pxxx -A t > t.sql
#!/bin/bash
DATE=$(date + %F_%H-%M-%S)
HOST=localhost
USER=backup
PASS=123.com
BACKUP_DIR=/data/db_backup
DB_LIST=$(mysql -h$HOST -u$USER -p$PASS -s -e "show databases;" 2>/dev/null |egrep -v "Database|information_schema|mysql|performance_schema|sys\ ")
 
for DB in $DB_LIST; do
    BACKUP_DB_DIR=$BACKUP_DIR/${DB}_${DATE}
    [ ! -d $BACKUP_DB_DIR ] & & mkdir -p $BACKUP_DB_DIR &>/dev/null
    TABLE_LIST=$(mysql -h$HOST -u$USER -p$PASS -s -e "use $DB;show tables;" 2>/dev/null)
    for TABLE in $TABLE_LIST; do
        BACKUP_NAME=$BACKUP_DB_DIR/${TABLE}.sql
        if ! mysqldump -h$HOST -u$USER -p$PASS $DB $TABLE > $BACKUP_NAME 2>/dev/null; then
            echo "$BACKUP_NAME backup failed!"
        fi
    done
done

12. Nginx access log analysis

#!/bin/bash
# Log format: $remote_addr - $remote_user [$time_local] "$request" $status $body_bytes_sent "$http_referer" "$http_user_agent" "$http_x_forwarded_for"
LOG_FILE=$1
echo "Statistics on the 10 most visited IPs"
awk '{a[$1] + + }END{print "UV:",length(a);for(v in a)print v,a[v]}' $LOG_FILE |sort -k2 -nr |head -10
echo "---------------------"
 
echo "The most visited IPs during the statistical period"
awk '$4>="[01/Dec/2018:13:20:25" & amp; & amp; $4<="[27/Nov/2018:16:20:49"{a[ $1] + + }END{for(v in a)print v,a[v]}' $LOG_FILE |sort -k2 -nr|head -10
echo "---------------------"
 
echo "Statistics on the 10 most visited pages"
awk '{a[$7] + + }END{print "PV:",length(a);for(v in a){if(a[v]>10)print v,a[v]} }' $LOG_FILE |sort -k2 -nr
echo "---------------------"
 
echo "Statistics on the number of status codes accessed to the page"
awk '{a[$7" "$9] + + }END{for(v in a){if(a[v]>5)print v,a[v]}}' $LOG_FILE |sort - k3 -nr

13. Nginx access logs are automatically cut by day (week, month)

#!/bin/bash
#nginxlog directory
LOG_DIR=/www/server/nginx/logs
#Get the time of the previous day
YESTERDAY_TIME=$(date -d "yesterday" + %F)
#Archive log retrieval time
LOG_MONTH_DIR=$LOG_DIR/$(date + "%Y-%m")
#The name of the archive log
LOG_FILE_LIST="access.log"
 
for LOG_FILE in $LOG_FILE_LIST; do
    [ ! -d $LOG_MONTH_DIR ] & amp; & amp; mkdir -p $LOG_MONTH_DIR
    mv $LOG_DIR/$LOG_FILE $LOG_MONTH_DIR/${LOG_FILE}_${YESTERDAY_TIME}
done
 
kill -USR1 $(cat $LOG_DIR/nginx.pid)

14. Automatically publish Java projects (Tomcat)

#!/bin/bash
DATE=$(date + %F_%T)
 
TOMCAT_NAME=$1
TOMCAT_DIR=/usr/local/$TOMCAT_NAME
ROOT=$TOMCAT_DIR/webapps/ROOT
 
BACKUP_DIR=/data/backup
WORK_DIR=/tmp
PROJECT_NAME=tomcat-java-demo
 
# Pull code
cd $WORK_DIR
if [ ! -d $PROJECT_NAME ]; then
   git clone https://github.com/lizhenliang/tomcat-java-demo
   cd $PROJECT_NAME
else
   cd $PROJECT_NAME
   git pull
fi
 
# Construct
mvn clean package -Dmaven.test.skip=true
if [ $? -ne 0 ]; then
   echo "maven build failure!"
   exit 1
fi
 
# deploy
TOMCAT_PID=$(ps -ef |grep "$TOMCAT_NAME" |egrep -v "grep|$$" |awk 'NR==1{print $2}')
[ -n "$TOMCAT_PID" ] & amp; & amp; kill -9 $TOMCAT_PID
[ -d $ROOT ] & amp; & amp; mv $ROOT $BACKUP_DIR/${TOMCAT_NAME}_ROOT$DATE
unzip $WORK_DIR/$PROJECT_NAME/target/*.war -d $ROOT
$TOMCAT_DIR/bin/startup.sh

15. Automatically publish PHP projects

#!/bin/bash
 
DATE=$(date + %F_%T)
 
WWWROOT=/usr/local/nginx/html/$1
 
 
BACKUP_DIR=/data/backup
WORK_DIR=/tmp
PROJECT_NAME=php-demo
 
 
# Pull code
cd $WORK_DIR
if [ ! -d $PROJECT_NAME ]; then
   git clone https://github.com/lizhenliang/php-demo
   cd $PROJECT_NAME
else
   cd $PROJECT_NAME
   git pull
fi
 
 
# deploy
if [ ! -d $WWWROOT ]; then
   mkdir -p $WWWROOT
   rsync -avz --exclude=.git $WORK_DIR/$PROJECT_NAME/* $WWWROOT
else
   rsync -avz --exclude=.git $WORK_DIR/$PROJECT_NAME/* $WWWROOT
fi

16. DOS attack prevention (automatic blocking of attack IP)

#!/bin/bash
DATE=$(date + %d/%b/%Y:%H:%M)
#nginxlog
LOG_FILE=/usr/local/nginx/logs/demo2.access.log
#Analyze IP access status
ABNORMAL_IP=$(tail -n5000 $LOG_FILE |grep $DATE |awk '{a[$1] + + }END{for(i in a)if(a[i]>10)print i}')
for IP in $ABNORMAL_IP; do
    if [ $(iptables -vnL |grep -c "$IP") -eq 0 ]; then
        iptables -I INPUT -s $IP -j DROP
        echo "$(date + '%F_%T') $IP" >> /tmp/drop_ip.log
    fi
done

17. Directory intrusion detection and alarm

#!/bin/bash
 
MON_DIR=/opt
inotifywait -mqr --format %f -e create $MON_DIR |\
while read files; do
   #Sync files
   rsync -avz /opt /tmp/opt
  #Check whether the file has been modified
   #echo "$(date + '%F %T') create $files" | mail -s "dir monitor" [email protected]
done